Package org.apache.tapestry5.internal.plastic

## Class AbstractAnnotationBuilder

- java.lang.Object
- - org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor
  - - org.apache.tapestry5.internal.plastic.AbstractAnnotationBuilder

- Direct Known Subclasses:
    `AnnotationBuilder`

      public abstract class AbstractAnnotationBuilder
      extends org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected PlasticClassPool` | `pool` |

    - ### Fields inherited from class org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor

      `api, av`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractAnnotationBuilder​(PlasticClassPool pool)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected Class` | `elementTypeForArrayAttribute​(String name)` |
    `protected abstract void` | `store​(String name, Object value)` |
    `void` | `visit​(String name, Object value)` | Visits a primitive value of the annotation.
    `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor` | `visitAnnotation​(String name, String desc)` | Visits a nested annotation value of the annotation.
    `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor` | `visitArray​(String name)` | Visits an array value of the annotation.
    `void` | `visitEnd()` | Visits the end of the annotation.
    `void` | `visitEnum​(String name, String desc, String value)` | Visits an enumeration value of the annotation.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### pool

          protected final PlasticClassPool pool

  - ### Constructor Detail

    - #### AbstractAnnotationBuilder

          public AbstractAnnotationBuilder​(PlasticClassPool pool)

  - ### Method Detail

    - #### store

          protected abstract void store​(String name,
                                        Object value)

    - #### elementTypeForArrayAttribute

          protected Class elementTypeForArrayAttribute​(String name)

    - #### visit

          public void visit​(String name,
                            Object value)

      Description copied from class: `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Visits a primitive value of the annotation.
      Overrides:
        `visit` in class `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Parameters:
        `name` - the value name.
        `value` - the actual value, whose type must be `Byte`, `Boolean`, `Character`, `Short`, `Integer` , `Long`, `Float`, `Double`, `String` or `Type` of `Type.OBJECT` or `Type.ARRAY` sort. This value can also be an array of byte, boolean, short, char, int, long, float or double values (this is equivalent to using `AnnotationVisitor.visitArray(java.lang.String)` and visiting each array element in turn, but is more convenient).

    - #### visitEnum

          public void visitEnum​(String name,
                                String desc,
                                String value)

      Description copied from class: `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Visits an enumeration value of the annotation.
      Overrides:
        `visitEnum` in class `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Parameters:
        `name` - the value name.
        `desc` - the class descriptor of the enumeration class.
        `value` - the actual enumeration value.

    - #### visitAnnotation

          public org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor visitAnnotation​(String name,
                                                                                             String desc)

      Description copied from class: `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Visits a nested annotation value of the annotation.
      Overrides:
        `visitAnnotation` in class `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Parameters:
        `name` - the value name.
        `desc` - the class descriptor of the nested annotation class.
      Returns:
        a visitor to visit the actual nested annotation value, or null if this visitor is not interested in visiting this nested annotation. The nested annotation value must be fully visited before calling other methods on this annotation visitor.

    - #### visitArray

          public org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor visitArray​(String name)

      Description copied from class: `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Visits an array value of the annotation. Note that arrays of primitive values (such as byte, boolean, short, char, int, long, float or double) can be passed as value to `visit`. This is what `ClassReader` does for non empty arrays of primitive values.
      Overrides:
        `visitArray` in class `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Parameters:
        `name` - the value name.
      Returns:
        a visitor to visit the actual array value elements, or null if this visitor is not interested in visiting these values. The 'name' parameters passed to the methods of this visitor are ignored. All the array values must be visited before calling other methods on this annotation visitor.

    - #### visitEnd

          public void visitEnd()

      Description copied from class: `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`
      Visits the end of the annotation.
      Overrides:
        `visitEnd` in class `org.apache.tapestry5.internal.plastic.asm.AnnotationVisitor`